/***************************************************************************
**    xLineEdit.cpp  $Revision: 1.2 $ - $Name:  $ 
**    xFrame w/ xEdit and QLabel widgets
**
**    Copyright (C) 1996 Joseph Croft <jcroft@unicomp.net>
**
**    This library is free software; you can redistribute it and/or
**    modify it under the terms of the GNU Library General Public
**    License as published by the Free Software Foundation; either
**    version 2 of the License, or (at your option) any later version.
**
**    This library is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**    Library General Public License for more details.
**
**    You should have received a copy of the GNU Library General Public
**    License along with this library; if not, write to the Free
**    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
 ***************************************************************************/
#include <stdio.h>
#include <ctype.h>
#include "xLineEdit.h"

static int dbg = 0;

xLineEdit::xLineEdit(QWidget *pParent, const char *pName, int alignLabel) :
        xFrame(pParent, pName)
{
   if (dbg) fprintf(stdout, "xLineEdit::xLineEdit():Enter\n\r");
   setResizeMode(xSPACE_Resize);
   setAcceptFocus(TRUE);   
   setFont(QFont("helvetica", 10, QFont::Bold));
   pEdit = new xEdit(this);
   pLabel = new QLabel(pName, this);
   pLabel->setAlignment(alignLabel);
   addWidget(pLabel);
   addWidget(pEdit);
   setWidgetSpacing(0);
   setMargins(5, 5);
   fitFrame();
   connect(pEdit, SIGNAL(returnPressed()), this, SLOT(gotReturn()));
   if (dbg) fprintf(stdout, "xLineEdit::xLineEdit():Exit\n\r");
}

xLineEdit::~xLineEdit()
{
   if (pEdit)
      delete pEdit;
   if (pLabel)
      delete pLabel;
}

void xLineEdit::setLabel(const char *pText)
{
   if (dbg) fprintf(stdout, "xLineEdit::setLabel():Enter\n\r");
   pLabel->setText(pText);
   pLabel->adjustSize();
   if (dbg) fprintf(stdout, "xLineEdit::setLabel():size w=%d X h=%d\n\r",
                            pLabel->size().width(), pLabel->size().height());
   if (dbg) fprintf(stdout, "xLineEdit::setLabel():Exit\n\r");
}

void xLineEdit::fitFrame(QSize *frameSize)
{
   QFontMetrics fm = pEdit->QWidget::fontMetrics();
   
   if (dbg) fprintf(stdout, "xLineEdit::fitFrame():font.lineSpacing = %d\n\r",
                             fm.lineSpacing());
   pEdit->resize(pEdit->size().width(), fm.lineSpacing() + 5);
   xFrame::fitFrame(frameSize);
}

/*
void xLineEdit::keyPressEvent(QKeyEvent *pEvt)
{
   if (pEvt->ascii() == '\t')
      emit tabPressed();
   else
      QLineEdit::keyPressEvent(pEvt);
}
*/
#include "xLineEdit.moc"
