/***************************************************************************
**    xMisc.cpp  $Revision: 1.2 $ - $Name:  $ 
**    Misc utility routines
**
**    Copyright (C) 1996 Joseph Croft <jcroft@unicomp.net>
**
**    This library is free software; you can redistribute it and/or
**    modify it under the terms of the GNU Library General Public
**    License as published by the Free Software Foundation; either
**    version 2 of the License, or (at your option) any later version.
**
**    This library is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**    Library General Public License for more details.
**
**    You should have received a copy of the GNU Library General Public
**    License along with this library; if not, write to the Free
**    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
 ***************************************************************************/

#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include "xMisc.h"

static int dbg = 0;

char strtoc(const char *pStr, const char **rtnStr)
{
   char rv, ch;
   int base;

   if (*pStr == '\\')
   {
      pStr++;
      if (toupper(*pStr) == 'X')
      {
         base = 16;
         pStr++;
      }
      else if (*pStr == '0')
         base = 8;
      else if (isdigit(*pStr))
         base = 10;
      else
      {
         rv = *(pStr++);
         if (rtnStr != NULL)
            *rtnStr = pStr;
         return(rv);
      }

      for (rv = 0; *pStr;)
      {         
         if (base == 16)
         {
            if (dbg) printf("strtoc():base 16, ch = 0x%x, %c\n\r", *pStr, *pStr);
            if (isxdigit(*pStr))
            {
               rv *= 16;
               if ((ch = toupper(*pStr) - '0') > 9)
                  rv += ch - 7;
               else
                  rv += ch;
               if (dbg) printf("strtoc():base 16, rslt = 0x%x\n\r", rv);
               pStr++;
            }
            else
               break;
         }
         else if (base == 8)
         {
            if (dbg) printf("strtoc():base 8, ch = 0x%x, %c\n\r", *pStr, *pStr);
            if (*pStr >= '0' && *pStr <= '7')
            {
               rv *= 8;
               rv += *pStr - '0';
               if (dbg) printf("strtoc():base 8, rslt = 0%x\n\r", rv);
               pStr++;
            }
            else
               break;
         }
         else
         {
            if (dbg) printf("strtoc():base 10, ch = 0x%x, %c\n\r", *pStr, *pStr);
            if (isdigit(*pStr))
            {
               rv *= 10;
               rv += *pStr - '0';
               if (dbg) printf("strtoc():base 10, rslt = 0x%x\n\r", rv);
               pStr++;
            }
            else
               break;
         }
         if (dbg) printf("strtoc():exit(%d)\n", rv);
      }
   }
   else
      rv = *(pStr++);

   if (rtnStr != NULL)
      *rtnStr = pStr;
   return(rv);
}


