/***************************************************************************
**    xIrcDccSocket.cpp  $Revision: 1.2 $ - $Name:  $ 
**    Class for Irc DCC Sockets
**
** Copyright (C) 1995, 1996  Joseph Croft <jcroft@unicomp.net>  
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
 ***************************************************************************/
#include <errno.h>
#include <ctype.h>
#include <stdlib.h>
#include <qstring.h>
#include <qmsgbox.h>
#include "xIrcDccSocket.h"

static int dbg = 0;

xIrcDccSocket::xIrcDccSocket(QWidget *pParent, const char *pName) :
               xSocketTCP(pParent, (char *)pName)
{
   if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():Enter\n");
   if (dbg) fflush(stdout);
   if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():Exit\n");
   if (dbg) fflush(stdout);
}

xIrcDccSocket::~xIrcDccSocket()
{
   disconnect(this);
}

bool xIrcDccSocket::connectTo(const char *pNetAddr)
{
   QString strHost(""), strServ("");
   const char *cp;
   int rv = TRUE;

   if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():Enter\n");
   if (dbg) fflush(stdout);
   if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():pNetAddr = |%s|\n", pNetAddr);
   if (dbg) fflush(stdout);
   for (cp = (const char *)pNetAddr; isspace(*cp); cp++);
   for (; *cp && !isspace(*cp); cp++)
      strHost += *cp;
   if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():strHost = |%s|\n", 
                             (const char *)strHost);
   if (dbg) fflush(stdout);
   while (isspace(*cp)) cp++;
   for (; *cp && !isspace(*cp); cp++)
      strServ += *cp;
   if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():strServ = |%s|\n", 
                             (const char *)strServ);
   if (strlen(strServ) == 0 || strlen(strHost) == 0)
   {
      QMessageBox::message("Error", "Could not connect:Invalid Address");
      rv = FALSE;
   }
   else
      rv = connectTo((const char *)strHost, (const char *)strServ);
   return(rv);
}

bool xIrcDccSocket::connectTo(const char *pHost, const char *pService)
{
   int rv = TRUE;
   char buf[256];

   if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():Enter\n");
   if (dbg) fflush(stdout);
   if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():Attempting connection Host:%s, port %s\n",
                             pHost, pService);
   if (dbg) fflush(stdout);
   if ((rv = xSocketTCP::connectTo(pHost, pService) == FALSE))
   {
      if (dbg) fprintf(stdout, "xIrcDccSocket::xIrcDccSocket():Attempt Failed\n");
      if (dbg) fflush(stdout);
      sprintf(buf, "Error connecting:%s\n", strerror(errno));
      QMessageBox::message("Error", buf);
   }
   return(rv);
}   

#include "xIrcDccSocket.moc"

/*
void xIrcDccSocket::socketIn(char *pText)
{
   const char *cp;
   int crFlag;
   char buf[512];

   if (dbg > 3) fprintf(stdout, "xIrcDccSocket::socketIn(): Enter\n");
   if (dbg > 3) fflush(stdout);
   for (crFlag = 0; *pText; pText++)
   {
      if (crFlag)
      {
         if (*pText == '\n')
            pText++;

         socketData += '\n';
         emit dataIn(const char *)socketData);
         socketData = "";
         crFlag = 0;
      }
      if (*pText == '\r')
         crFlag = 1;
      else
      {
         socketData += *pText;
         if (*pText == '\n')
         {
            emit dataIn(const char *)socketData);
            socketData = "";
         }
      }
   }
   if (dbg > 3) fprintf(stdout, "xIrcDccSocket::socketIn(): Exit\n");
   if (dbg > 3) fflush(stdout);
}
*/
